/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.65 Revision 1.77
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/vdr-plugin.eclass,v 1.65 2008/07/03 11:18:13 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/vdr-plugin.eclass,v 1.77 2011/12/31 01:01:56 hd_brummy Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
9# vdr-plugin.eclass 9# vdr-plugin.eclass
10# 10#
11# eclass to create ebuilds for vdr plugins 11# eclass to create ebuilds for vdr plugins
12# 12#
13 13
14# Example ebuild (vdr-femon): 14# Example ebuild (basic version without patching):
15# 15#
16# EAPI="2"
16# inherit vdr-plugin 17# inherit vdr-plugin
17# IUSE="" 18# IUSE=""
18# SLOT="0" 19# SLOT="0"
19# DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)" 20# DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)"
20# HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/" 21# HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/"
21# SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz" 22# SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz"
22# LICENSE="GPL-2" 23# LICENSE="GPL-2"
23# KEYWORDS="~x86" 24# KEYWORDS="~x86"
24# DEPEND=">=media-video/vdr-1.3.27" 25# DEPEND=">=media-video/vdr-1.6.0"
25# 26#
26# 27#
28
29# For patching you should modify src_prepare phase:
30#
31# src_prepare() {
32# epatch "${FILESDIR}"/${P}-xxx.patch
33# vdr-plugin_src_prepare
34# }
27 35
28# Installation of a config file for the plugin 36# Installation of a config file for the plugin
29# 37#
30# If ${VDR_CONFD_FILE} is set install this file 38# If ${VDR_CONFD_FILE} is set install this file
31# else install ${FILESDIR}/confd if it exists. 39# else install ${FILESDIR}/confd if it exists.
57# 65#
58# all patches which ending on diff or patch in this DIR will automatically applied 66# all patches which ending on diff or patch in this DIR will automatically applied
59# 67#
60 68
61inherit base multilib eutils flag-o-matic 69inherit base multilib eutils flag-o-matic
70
71if ! has "${EAPI:-0}" 0 1 2 3; then
72 die "API of vdr-plugin.eclass in EAPI=\"${EAPI}\" not established"
73fi
62 74
63IUSE="" 75IUSE=""
64 76
65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 77# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66VDRPLUGIN="${PN/#vdrplugin-/}" 78VDRPLUGIN="${PN/#vdrplugin-/}"
77 89
78DEPEND="${COMMON_DEPEND} 90DEPEND="${COMMON_DEPEND}
79 media-tv/linuxtv-dvb-headers" 91 media-tv/linuxtv-dvb-headers"
80RDEPEND="${COMMON_DEPEND} 92RDEPEND="${COMMON_DEPEND}
81 >=app-admin/eselect-vdr-0.0.2" 93 >=app-admin/eselect-vdr-0.0.2"
94
95# this is a hack for ebuilds like vdr-xineliboutput that want to
96# conditionally install a vdr-plugin
97if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]]; then
98 # make DEPEND conditional
99 IUSE="${IUSE} vdr"
100 DEPEND="vdr? ( ${DEPEND} )"
101 RDEPEND="vdr? ( ${RDEPEND} )"
102fi
82 103
83# New method of storing plugindb 104# New method of storing plugindb
84# Called from src_install 105# Called from src_install
85# file maintained by normal portage-methods 106# file maintained by normal portage-methods
86create_plugindb_file() { 107create_plugindb_file() {
154 done 175 done
155} 176}
156 177
157fix_vdr_libsi_include() 178fix_vdr_libsi_include()
158{ 179{
159 einfo "Fixing include of libsi-headers" 180 #einfo "Fixing include of libsi-headers"
160 local f 181 local f
161 for f; do 182 for f; do
162 sed -i "${f}" \ 183 sed -i "${f}" \
163 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \ 184 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
164 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:' 185 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
184 # To satisfy 1-3 we do this: 205 # To satisfy 1-3 we do this:
185 # Set VDRDIR=/usr/include/vdr 206 # Set VDRDIR=/usr/include/vdr
186 # Set VDRINCDIR=/usr/include 207 # Set VDRINCDIR=/usr/include
187 # Change $(VDRDIR)/include to $(VDRINCDIR) 208 # Change $(VDRDIR)/include to $(VDRINCDIR)
188 209
189 ebegin " Setting paths"
190 sed -i Makefile \ 210 sed -i Makefile \
191 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \ 211 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
192 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \ 212 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
193 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \ 213 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
194 \ 214 \
195 -e 's:-I$(DVBDIR)/include::' \ 215 -e 's:-I$(DVBDIR)/include::' \
196 -e 's:-I$(DVBDIR)::' 216 -e 's:-I$(DVBDIR)::'
197 eend 0
198 217
199 # maybe needed for multiproto: 218 # maybe needed for multiproto:
200 #sed -i Makefile \ 219 #sed -i Makefile \
201 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 220 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
202 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' 221 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
218 237
219 # Disabling file stripping, useful for debugging 238 # Disabling file stripping, useful for debugging
220 sed -i Makefile \ 239 sed -i Makefile \
221 -e '/@.*strip/d' \ 240 -e '/@.*strip/d' \
222 -e '/strip \$(LIBDIR)\/\$@/d' \ 241 -e '/strip \$(LIBDIR)\/\$@/d' \
223 -e '/@.*\$(STRIP)/d' 242 -e 's/STRIP.*=.*$/STRIP = true/'
224 243
225 # Use a file instead of a variable as single-stepping via ebuild 244 # Use a file instead of a variable as single-stepping via ebuild
226 # destroys environment. 245 # destroys environment.
227 touch "${WORKDIR}"/.vdr-plugin_makefile_patched 246 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
228} 247}
244plugin_has_gettext() { 263plugin_has_gettext() {
245 [[ -d po ]] 264 [[ -d po ]]
246} 265}
247 266
248vdr_i18n_convert_to_gettext() { 267vdr_i18n_convert_to_gettext() {
268 if has_version ">=media-video/vdr-1.7.22"; then
269 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext"
270 else
249 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl" 271 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
272 fi
250 273
251 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then 274 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
252 ewarn "Conversion to gettext disabled in ebuild" 275 ewarn "Conversion to gettext disabled in ebuild"
253 return 1 276 return 1
254 fi 277 fi
284 return 1 307 return 1
285 fi 308 fi
286} 309}
287 310
288vdr_i18n_disable_gettext() { 311vdr_i18n_disable_gettext() {
289 ebegin "Disabling gettext support in plugin" 312 #einfo "Disabling gettext support in plugin"
313
290 # Remove i18n Target if using older vdr 314 # Remove i18n Target if using older vdr
291 sed -i Makefile \ 315 sed -i Makefile \
292 -e '/^all:/s/ i18n//' 316 -e '/^all:/s/ i18n//'
293 eend 0
294} 317}
295 318
296vdr_i18n() { 319vdr_i18n() {
297 if vdr_has_gettext; then 320 if vdr_has_gettext; then
298 einfo "VDR has gettext support" 321 #einfo "VDR has gettext support"
299 if plugin_has_gettext; then 322 if plugin_has_gettext; then
300 einfo "Plugin has gettext support, fine" 323 #einfo "Plugin has gettext support, fine"
301 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then 324 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
302 ewarn "Please remove left over NO_GETTEXT_HACK." 325 ewarn "Please remove unneeded NO_GETTEXT_HACK from ebuild."
303 fi 326 fi
304 else 327 else
305 vdr_i18n_convert_to_gettext 328 vdr_i18n_convert_to_gettext
306 if [[ $? != 0 ]]; then 329 if [[ $? != 0 ]]; then
307 eerror "" 330 eerror ""
308 eerror "Plugin will have only english OSD texts" 331 eerror "Plugin will have only english OSD texts"
309 eerror "it needs manual fixing." 332 eerror "it needs manual fixing."
310 fi 333 fi
311 fi 334 fi
312 else 335 else
313 einfo "VDR has no gettext support" 336 #einfo "VDR has no gettext support"
314 if plugin_has_gettext; then 337 if plugin_has_gettext; then
315 vdr_i18n_disable_gettext 338 vdr_i18n_disable_gettext
316 fi 339 fi
317 fi 340 fi
318} 341}
355 elog "To activate a plugin execute this command:" 378 elog "To activate a plugin execute this command:"
356 elog "\teselect vdr-plugin enable <plugin_name> ..." 379 elog "\teselect vdr-plugin enable <plugin_name> ..."
357 elog 380 elog
358} 381}
359 382
383has_vdr() {
384 [[ -f "${VDR_INCLUDE_DIR}"/config.h ]]
385}
360 386
361## exported functions 387## exported functions
362 388
363vdr-plugin_pkg_setup() { 389vdr-plugin_pkg_setup() {
364 # -fPIC is needed for shared objects on some platforms (amd64 and others) 390 # -fPIC is needed for shared objects on some platforms (amd64 and others)
365 append-flags -fPIC 391 append-flags -fPIC
366 392
393 # Plugins need to be compiled with position independent code, otherwise linking
394 # VDR against it will fail
395 if has_version ">=media-video/vdr-1.7.13"; then
396 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
397 fi
398
367 # Where should the plugins live in the filesystem 399 # Where should the plugins live in the filesystem
368 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins" 400 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
369 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums" 401 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
370 402
371 # was /usr/lib/... some time ago 403 # was /usr/lib/... some time ago
375 # Pathes to includes 407 # Pathes to includes
376 VDR_INCLUDE_DIR="/usr/include/vdr" 408 VDR_INCLUDE_DIR="/usr/include/vdr"
377 DVB_INCLUDE_DIR="/usr/include" 409 DVB_INCLUDE_DIR="/usr/include"
378 410
379 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale" 411 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
412 if has_version ">=media-video/vdr-1.6.0_p2-r7"; then
413 LOCDIR="/usr/share/locale"
414 else
380 LOCDIR="/usr/share/vdr/locale" 415 LOCDIR="/usr/share/vdr/locale"
416 fi
417
418 if ! has_vdr; then
419 # set to invalid values to detect abuses
420 VDRVERSION="eclass_no_vdr_installed"
421 APIVERSION="eclass_no_vdr_installed"
422
423 if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]] && ! use vdr; then
424 einfo "VDR not found!"
425 else
426 # if vdr is required
427 die "VDR not found!"
428 fi
429 return
430 fi
381 431
382 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 432 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
383 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 433 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
384 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 434 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
385 435
386 einfo "Compiling against" 436 einfo "Compiling against"
387 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]" 437 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
438}
439
440vdr-plugin_src_util() {
441
442 while [ "$1" ]; do
443
444 case "$1" in
445 all)
446 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
447 ;;
448 prepare|all_but_unpack)
449 vdr-plugin_src_util add_local_patch patchmakefile i18n
450 ;;
451 unpack)
452 base_src_unpack
453 ;;
454 add_local_patch)
455 cd "${S}" || die "Could not change to plugin-source-directory!"
456 vdr_add_local_patch
457 ;;
458 patchmakefile)
459 cd "${S}" || die "Could not change to plugin-source-directory!"
460 vdr_patchmakefile
461 ;;
462 i18n)
463 cd "${S}" || die "Could not change to plugin-source-directory!"
464 vdr_i18n
465 ;;
466 esac
467
468 shift
469 done
388} 470}
389 471
390vdr-plugin_src_unpack() { 472vdr-plugin_src_unpack() {
391 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 473 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
392 eerror "Wrong use of vdr-plugin.eclass." 474 eerror "Wrong use of vdr-plugin.eclass."
393 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 475 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
394 echo 476 echo
395 eerror "Please report this at bugs.gentoo.org." 477 eerror "Please report this at bugs.gentoo.org."
396 die "vdr-plugin_pkg_setup not called!" 478 die "vdr-plugin_pkg_setup not called!"
397 fi 479 fi
398 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n 480 if [ -z "$1" ]; then
481 case "${EAPI:-0}" in
482 2|3)
483 vdr-plugin_src_util unpack
484 ;;
485 *)
486 vdr-plugin_src_util all
487 ;;
488 esac
489
490 else
491 vdr-plugin_src_util $@
492 fi
493}
494
495vdr-plugin_src_prepare() {
496 base_src_prepare
497 vdr-plugin_src_util prepare
498}
499
500vdr-plugin_src_compile() {
501 [ -z "$1" ] && vdr-plugin_src_compile copy_source compile
399 502
400 while [ "$1" ]; do 503 while [ "$1" ]; do
401 504
402 case "$1" in 505 case "$1" in
403 all_but_unpack) 506 copy_source)
404 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
405 ;;
406 unpack)
407 base_src_unpack
408 ;;
409 add_local_patch)
410 cd "${S}" || die "Could not change to plugin-source-directory!"
411 vdr_add_local_patch
412 ;;
413 patchmakefile)
414 cd "${S}" || die "Could not change to plugin-source-directory!"
415 vdr_patchmakefile
416 ;;
417 i18n)
418 cd "${S}" || die "Could not change to plugin-source-directory!"
419 vdr_i18n
420 ;;
421 esac
422
423 shift
424 done
425}
426
427vdr-plugin_src_compile() {
428 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
429
430 while [ "$1" ]; do
431
432 case "$1" in
433 prepare)
434 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 507 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
435 ;; 508 ;;
436 compile) 509 compile)
437 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then 510 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
438 eerror "Wrong use of vdr-plugin.eclass." 511 eerror "Wrong use of vdr-plugin.eclass."
546vdr-plugin_pkg_config() { 619vdr-plugin_pkg_config() {
547 ewarn "emerge --config ${PN} is no longer supported" 620 ewarn "emerge --config ${PN} is no longer supported"
548 vdr-plugin_print_enable_command 621 vdr-plugin_print_enable_command
549} 622}
550 623
624case "${EAPI:-0}" in
625 2|3)
626 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
627 ;;
628 *)
551EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 629 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
630 ;;
631esac

Legend:
Removed from v.1.65  
changed lines
  Added in v.1.77

  ViewVC Help
Powered by ViewVC 1.1.20